0
点赞
收藏
分享

微信扫一扫

python 异常处理

 

1. 什么是异常 

  异常就是程序运行时发生错误的信号,异常发生之后, 异常之后的代码就不执行了, 在python中,错误触发的异常如下:

python 异常处理_异常处理

x


Traceback (most recent call last):
File "D:/pycharm/code/异常处理.py", line 153, in <module>
x
NameError: name 'x' is not defined

python 异常处理_异常处理

2. python中异常的种类

 

python 异常处理_异常处理

# AttributeError 试图访问一个对象没有的树形,比如foo.x,但是foo没有属性x
# IOError 输入/输出异常;基本上是无法打开文件
# ImportError 无法引入模块或包;基本上是路径问题或名称错误
# IndentationError 语法错误(的子类) ;代码没有正确对齐
# IndexError 下标索引超出序列边界,比如当x只有三个元素,却试图访问x[5]
# KeyError 试图访问字典里不存在的键
# KeyboardInterrupt Ctrl+C被按下
# NameError 使用一个还未被赋予对象的变量
# SyntaxError Python代码非法,代码不能编译(个人认为这是语法错误,写错了)
# TypeError 传入对象类型与要求的不符合
# UnboundLocalError 试图访问一个还未被设置的局部变量,基本上是由于另有一个同名的全局变量,导致你以为正在访问它
# ValueError 传入一个调用者不期望的值,即使值的类型是正确的

python 异常处理_异常处理

 

3. 异常处理

  python为每一种异常定制了一个类型,然后提供了一种特定的语法结构用来进行异常处理.

 (1) try   except

  语法 : 

try:
被检测的代码块
except 异常类型:
try中一旦检测到异常,就执行这个位置的逻辑

  例如 :

 

import os
import sys
def main():
os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'myblog.settings')
try:
from django.core.management import execute_from_command_line
except ImportError as exc:
raise ImportError(
"Couldn't import Django. Are you sure it's installed and "
"available on your PYTHONPATH environment variable? Did you "
"forget to activate a virtual environment?"
) from exc
execute_from_command_line(sys.argv)

 

python 异常处理_异常处理

l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
num = int(input('num :')) # 输入的应为1,2,3
print(l[num - 1])

python 异常处理_异常处理

# 当我们输入num值为 4 时出现错误: IndexError: list index out of range
# 用异常处理
l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
try:
num = int(input('num :'))
print(l[num - 1])
except IndexError: # 当出现 IndexError 时执行以下语句
print('您输入的数字无效')

python 异常处理_异常处理python 异常处理_异常处理

# 当我们输入num值为 a 时出现错误: ValueError: invalid literal for int() with base 10: 'a'
l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
try:
num = int(input('num :'))
print(l[num - 1])
except ValueError: # 当出现 ValueError 时执行以下语句
print('请输入一个数字')

python 异常处理_异常处理python 异常处理_异常处理

# 多分支异常处理
l = ['登录','注册','退出']
for i in enumerate(l,1):
print(i[0],i[1])
try:
num = int(input('num :'))
print(l[num-1])
except ValueError:
print('请输入一个数字')
except IndexError:
print('您输入的数字无效')

python 异常处理_异常处理python 异常处理_异常处理

# 万能异常
l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
try:
num = int(input('num :'))
print(l[num - 1])
except Exception as 变量名:
print(type(变量名), 变量名, 变量名.__traceback__.tb_lineno)

# num输入为a时 : <class 'ValueError'> invalid literal for int() with base 10: 'a' 70
# num输入为4时 : <class 'IndexError'> list index out of range 71

python 异常处理_异常处理

 

python 异常处理_异常处理

  注意 : 万能异常和其他分支合作 : 万能异常永远要放在所有except的最后.

 (2) 异常处理的其他机制

  1)

python 异常处理_异常处理

s1 = 'hello'
try:
int(s1)
except IndexError as e:
print(e)
except KeyError as e:
print(e)
except ValueError as e:
print(e)
#except Exception as e:
# print(e)
else:
print('try内代码块没有异常则执行我')
finally:
print('无论异常与否,都会执行该模块,通常是进行清理工作')

python 异常处理_异常处理

 例如 :

python 异常处理_异常处理

l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
try:
num = int(input('num :'))
print(l[num - 1])
except IndexError:
print('请输入一个数字')
else: # try中的代码正常执行 没有异常的时候会执行else中的代码
print('执行else')
finally: # 无论如何都会执行 可以用于操作系统资源归还的工作
print('执行finally')

# num输入为1时 : 登录
# 行else
# 执行finally

# num输入为4时 : 请输入一个数字
# 执行finally

python 异常处理_异常处理

  2) 主动抛异常

python 异常处理_异常处理

# 主动抛异常
# try:
# num = int(input('>>>'))
# except Exception:
# print('在出现了异常之后做点儿什么,再让它抛异常')
# raise # 原封不动的抛出try语句中出现的异常

python 异常处理_异常处理python 异常处理_异常处理

# 自定义异常
raise NameError('这是一个name error的异常')
class EvaException(Exception):
def __init__(self,msg):
self.msg = msg

raise EvaException('这是一个什么什么错误,有什么问题')

python 异常处理_异常处理

  3) 断言

python 异常处理_异常处理

# assert 布尔值
assert True
if False:
print(1234234)
else:
raise AssertionError # AssertionError

python 异常处理_异常处理

  总结 :

python 异常处理_异常处理

# 异常处理的几种模式
# try/except
# try/except/else
# try/except/else/finally
# try/except/finally
# try/finally

# 尽量少用异常处理
# 能通过逻辑规避的应该代码逻辑规避掉
# 应该对某一句/几句话来进行处理

# 最后 在外层添加一个大的异常处理

python 异常处理_异常处理

 

心有猛虎,细嗅蔷薇

1. 什么是异常 

  异常就是程序运行时发生错误的信号,异常发生之后, 异常之后的代码就不执行了, 在python中,错误触发的异常如下:

python 异常处理_异常处理

x


Traceback (most recent call last):
File "D:/pycharm/code/异常处理.py", line 153, in <module>
x
NameError: name 'x' is not defined

python 异常处理_异常处理

2. python中异常的种类

 

python 异常处理_异常处理

# AttributeError 试图访问一个对象没有的树形,比如foo.x,但是foo没有属性x
# IOError 输入/输出异常;基本上是无法打开文件
# ImportError 无法引入模块或包;基本上是路径问题或名称错误
# IndentationError 语法错误(的子类) ;代码没有正确对齐
# IndexError 下标索引超出序列边界,比如当x只有三个元素,却试图访问x[5]
# KeyError 试图访问字典里不存在的键
# KeyboardInterrupt Ctrl+C被按下
# NameError 使用一个还未被赋予对象的变量
# SyntaxError Python代码非法,代码不能编译(个人认为这是语法错误,写错了)
# TypeError 传入对象类型与要求的不符合
# UnboundLocalError 试图访问一个还未被设置的局部变量,基本上是由于另有一个同名的全局变量,导致你以为正在访问它
# ValueError 传入一个调用者不期望的值,即使值的类型是正确的

python 异常处理_异常处理

 

3. 异常处理

  python为每一种异常定制了一个类型,然后提供了一种特定的语法结构用来进行异常处理.

 (1) try   except

  语法 : 

try:
被检测的代码块
except 异常类型:
try中一旦检测到异常,就执行这个位置的逻辑

  例如 :

 

import os
import sys
def main():
os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'myblog.settings')
try:
from django.core.management import execute_from_command_line
except ImportError as exc:
raise ImportError(
"Couldn't import Django. Are you sure it's installed and "
"available on your PYTHONPATH environment variable? Did you "
"forget to activate a virtual environment?"
) from exc
execute_from_command_line(sys.argv)

 

python 异常处理_异常处理

l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
num = int(input('num :')) # 输入的应为1,2,3
print(l[num - 1])

python 异常处理_异常处理

# 当我们输入num值为 4 时出现错误: IndexError: list index out of range
# 用异常处理
l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
try:
num = int(input('num :'))
print(l[num - 1])
except IndexError: # 当出现 IndexError 时执行以下语句
print('您输入的数字无效')

python 异常处理_异常处理python 异常处理_异常处理

# 当我们输入num值为 a 时出现错误: ValueError: invalid literal for int() with base 10: 'a'
l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
try:
num = int(input('num :'))
print(l[num - 1])
except ValueError: # 当出现 ValueError 时执行以下语句
print('请输入一个数字')

python 异常处理_异常处理python 异常处理_异常处理

# 多分支异常处理
l = ['登录','注册','退出']
for i in enumerate(l,1):
print(i[0],i[1])
try:
num = int(input('num :'))
print(l[num-1])
except ValueError:
print('请输入一个数字')
except IndexError:
print('您输入的数字无效')

python 异常处理_异常处理python 异常处理_异常处理

# 万能异常
l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
try:
num = int(input('num :'))
print(l[num - 1])
except Exception as 变量名:
print(type(变量名), 变量名, 变量名.__traceback__.tb_lineno)

# num输入为a时 : <class 'ValueError'> invalid literal for int() with base 10: 'a' 70
# num输入为4时 : <class 'IndexError'> list index out of range 71

python 异常处理_异常处理

 

python 异常处理_异常处理

  注意 : 万能异常和其他分支合作 : 万能异常永远要放在所有except的最后.

 (2) 异常处理的其他机制

  1)

python 异常处理_异常处理

s1 = 'hello'
try:
int(s1)
except IndexError as e:
print(e)
except KeyError as e:
print(e)
except ValueError as e:
print(e)
#except Exception as e:
# print(e)
else:
print('try内代码块没有异常则执行我')
finally:
print('无论异常与否,都会执行该模块,通常是进行清理工作')

python 异常处理_异常处理

 例如 :

python 异常处理_异常处理

l = ['登录', '注册', '退出']
for i in enumerate(l, 1):
print(i[0], i[1])
try:
num = int(input('num :'))
print(l[num - 1])
except IndexError:
print('请输入一个数字')
else: # try中的代码正常执行 没有异常的时候会执行else中的代码
print('执行else')
finally: # 无论如何都会执行 可以用于操作系统资源归还的工作
print('执行finally')

# num输入为1时 : 登录
# 行else
# 执行finally

# num输入为4时 : 请输入一个数字
# 执行finally

python 异常处理_异常处理

  2) 主动抛异常

python 异常处理_异常处理

# 主动抛异常
# try:
# num = int(input('>>>'))
# except Exception:
# print('在出现了异常之后做点儿什么,再让它抛异常')
# raise # 原封不动的抛出try语句中出现的异常

python 异常处理_异常处理python 异常处理_异常处理

# 自定义异常
raise NameError('这是一个name error的异常')
class EvaException(Exception):
def __init__(self,msg):
self.msg = msg

raise EvaException('这是一个什么什么错误,有什么问题')

python 异常处理_异常处理

  3) 断言

python 异常处理_异常处理

# assert 布尔值
assert True
if False:
print(1234234)
else:
raise AssertionError # AssertionError

python 异常处理_异常处理

  总结 :

python 异常处理_异常处理

# 异常处理的几种模式
# try/except
# try/except/else
# try/except/else/finally
# try/except/finally
# try/finally

# 尽量少用异常处理
# 能通过逻辑规避的应该代码逻辑规避掉
# 应该对某一句/几句话来进行处理

# 最后 在外层添加一个大的异常处理

python 异常处理_异常处理

 


举报

相关推荐

0 条评论